// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: SpeedAndStatesResponse.proto

package ru.omnicomm.pegasus.messaging.data.responses;

public final class SpeedAndStatesResponseParser {
  private SpeedAndStatesResponseParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public enum State
      implements com.google.protobuf.ProtocolMessageEnum {
    NORMAL(0, 0),
    LAST(1, 1),
    DEFECTIVE(2, 2),
    ;
    
    
    public final int getNumber() { return value; }
    
    public static State valueOf(int value) {
      switch (value) {
        case 0: return NORMAL;
        case 1: return LAST;
        case 2: return DEFECTIVE;
        default: return null;
      }
    }
    
    public static com.google.protobuf.Internal.EnumLiteMap<State>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static com.google.protobuf.Internal.EnumLiteMap<State>
        internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<State>() {
            public State findValueByNumber(int number) {
              return State.valueOf(number)
    ;        }
          };
    
    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(index);
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.getDescriptor().getEnumTypes().get(0);
    }
    
    private static final State[] VALUES = {
      NORMAL, LAST, DEFECTIVE, 
    };
    public static State valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }
    private final int index;
    private final int value;
    private State(int index, int value) {
      this.index = index;
      this.value = value;
    }
    
    static {
      ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.getDescriptor();
    }
    
    // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.data.responses.State)
  }
  
  public static final class SpeedAndStatesResponse extends
      com.google.protobuf.GeneratedMessage {
    // Use SpeedAndStatesResponse.newBuilder() to construct.
    private SpeedAndStatesResponse() {
      initFields();
    }
    private SpeedAndStatesResponse(boolean noInit) {}
    
    private static final SpeedAndStatesResponse defaultInstance;
    public static SpeedAndStatesResponse getDefaultInstance() {
      return defaultInstance;
    }
    
    public SpeedAndStatesResponse getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_fieldAccessorTable;
    }
    
    public static final class Row extends
        com.google.protobuf.GeneratedMessage {
      // Use Row.newBuilder() to construct.
      private Row() {
        initFields();
      }
      private Row(boolean noInit) {}
      
      private static final Row defaultInstance;
      public static Row getDefaultInstance() {
        return defaultInstance;
      }
      
      public Row getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_fieldAccessorTable;
      }
      
      // required string vehicleId = 101;
      public static final int VEHICLEID_FIELD_NUMBER = 101;
      private boolean hasVehicleId;
      private java.lang.String vehicleId_ = "";
      public boolean hasVehicleId() { return hasVehicleId; }
      public java.lang.String getVehicleId() { return vehicleId_; }
      
      // required double pointDate = 102;
      public static final int POINTDATE_FIELD_NUMBER = 102;
      private boolean hasPointDate;
      private double pointDate_ = 0D;
      public boolean hasPointDate() { return hasPointDate; }
      public double getPointDate() { return pointDate_; }
      
      // required double speed = 103;
      public static final int SPEED_FIELD_NUMBER = 103;
      private boolean hasSpeed;
      private double speed_ = 0D;
      public boolean hasSpeed() { return hasSpeed; }
      public double getSpeed() { return speed_; }
      
      // repeated string stateId = 104;
      public static final int STATEID_FIELD_NUMBER = 104;
      private java.util.List<java.lang.String> stateId_ =
        java.util.Collections.emptyList();
      public java.util.List<java.lang.String> getStateIdList() {
        return stateId_;
      }
      public int getStateIdCount() { return stateId_.size(); }
      public java.lang.String getStateId(int index) {
        return stateId_.get(index);
      }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasVehicleId) return false;
        if (!hasPointDate) return false;
        if (!hasSpeed) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasVehicleId()) {
          output.writeString(101, getVehicleId());
        }
        if (hasPointDate()) {
          output.writeDouble(102, getPointDate());
        }
        if (hasSpeed()) {
          output.writeDouble(103, getSpeed());
        }
        for (java.lang.String element : getStateIdList()) {
          output.writeString(104, element);
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasVehicleId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(101, getVehicleId());
        }
        if (hasPointDate()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(102, getPointDate());
        }
        if (hasSpeed()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(103, getSpeed());
        }
        {
          int dataSize = 0;
          for (java.lang.String element : getStateIdList()) {
            dataSize += com.google.protobuf.CodedOutputStream
              .computeStringSizeNoTag(element);
          }
          size += dataSize;
          size += 2 * getStateIdList().size();
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row result;
        
        // Construct using ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          if (result.stateId_ != java.util.Collections.EMPTY_LIST) {
            result.stateId_ =
              java.util.Collections.unmodifiableList(result.stateId_);
          }
          ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row other) {
          if (other == ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.getDefaultInstance()) return this;
          if (other.hasVehicleId()) {
            setVehicleId(other.getVehicleId());
          }
          if (other.hasPointDate()) {
            setPointDate(other.getPointDate());
          }
          if (other.hasSpeed()) {
            setSpeed(other.getSpeed());
          }
          if (!other.stateId_.isEmpty()) {
            if (result.stateId_.isEmpty()) {
              result.stateId_ = new java.util.ArrayList<java.lang.String>();
            }
            result.stateId_.addAll(other.stateId_);
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 810: {
                setVehicleId(input.readString());
                break;
              }
              case 817: {
                setPointDate(input.readDouble());
                break;
              }
              case 825: {
                setSpeed(input.readDouble());
                break;
              }
              case 834: {
                addStateId(input.readString());
                break;
              }
            }
          }
        }
        
        
        // required string vehicleId = 101;
        public boolean hasVehicleId() {
          return result.hasVehicleId();
        }
        public java.lang.String getVehicleId() {
          return result.getVehicleId();
        }
        public Builder setVehicleId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasVehicleId = true;
          result.vehicleId_ = value;
          return this;
        }
        public Builder clearVehicleId() {
          result.hasVehicleId = false;
          result.vehicleId_ = getDefaultInstance().getVehicleId();
          return this;
        }
        
        // required double pointDate = 102;
        public boolean hasPointDate() {
          return result.hasPointDate();
        }
        public double getPointDate() {
          return result.getPointDate();
        }
        public Builder setPointDate(double value) {
          result.hasPointDate = true;
          result.pointDate_ = value;
          return this;
        }
        public Builder clearPointDate() {
          result.hasPointDate = false;
          result.pointDate_ = 0D;
          return this;
        }
        
        // required double speed = 103;
        public boolean hasSpeed() {
          return result.hasSpeed();
        }
        public double getSpeed() {
          return result.getSpeed();
        }
        public Builder setSpeed(double value) {
          result.hasSpeed = true;
          result.speed_ = value;
          return this;
        }
        public Builder clearSpeed() {
          result.hasSpeed = false;
          result.speed_ = 0D;
          return this;
        }
        
        // repeated string stateId = 104;
        public java.util.List<java.lang.String> getStateIdList() {
          return java.util.Collections.unmodifiableList(result.stateId_);
        }
        public int getStateIdCount() {
          return result.getStateIdCount();
        }
        public java.lang.String getStateId(int index) {
          return result.getStateId(index);
        }
        public Builder setStateId(int index, java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.stateId_.set(index, value);
          return this;
        }
        public Builder addStateId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  if (result.stateId_.isEmpty()) {
            result.stateId_ = new java.util.ArrayList<java.lang.String>();
          }
          result.stateId_.add(value);
          return this;
        }
        public Builder addAllStateId(
            java.lang.Iterable<? extends java.lang.String> values) {
          if (result.stateId_.isEmpty()) {
            result.stateId_ = new java.util.ArrayList<java.lang.String>();
          }
          super.addAll(values, result.stateId_);
          return this;
        }
        public Builder clearStateId() {
          result.stateId_ = java.util.Collections.emptyList();
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse.Row)
      }
      
      static {
        defaultInstance = new Row(true);
        ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse.Row)
    }
    
    // required int32 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 0;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // optional string instanceId = 4;
    public static final int INSTANCEID_FIELD_NUMBER = 4;
    private boolean hasInstanceId;
    private java.lang.String instanceId_ = "";
    public boolean hasInstanceId() { return hasInstanceId; }
    public java.lang.String getInstanceId() { return instanceId_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse.Row rows = 201;
    public static final int ROWS_FIELD_NUMBER = 201;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row> rows_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row> getRowsList() {
      return rows_;
    }
    public int getRowsCount() { return rows_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row getRows(int index) {
      return rows_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
    public static final int BLOCKSTATE_FIELD_NUMBER = 300;
    private boolean hasBlockState;
    private ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State blockState_;
    public boolean hasBlockState() { return hasBlockState; }
    public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State getBlockState() { return blockState_; }
    
    // optional int32 blockNumber = 301;
    public static final int BLOCKNUMBER_FIELD_NUMBER = 301;
    private boolean hasBlockNumber;
    private int blockNumber_ = 0;
    public boolean hasBlockNumber() { return hasBlockNumber; }
    public int getBlockNumber() { return blockNumber_; }
    
    private void initFields() {
      blockState_ = ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State.NORMAL;
    }
    public final boolean isInitialized() {
      if (!hasMessageType) return false;
      for (ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row element : getRowsList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasInstanceId()) {
        output.writeString(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row element : getRowsList()) {
        output.writeMessage(201, element);
      }
      if (hasBlockState()) {
        output.writeEnum(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        output.writeInt32(301, getBlockNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasInstanceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row element : getRowsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(201, element);
      }
      if (hasBlockState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(301, getBlockNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.rows_ != java.util.Collections.EMPTY_LIST) {
          result.rows_ =
            java.util.Collections.unmodifiableList(result.rows_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.getDefaultInstance()) return this;
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasInstanceId()) {
          setInstanceId(other.getInstanceId());
        }
        if (!other.rows_.isEmpty()) {
          if (result.rows_.isEmpty()) {
            result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row>();
          }
          result.rows_.addAll(other.rows_);
        }
        if (other.hasBlockState()) {
          setBlockState(other.getBlockState());
        }
        if (other.hasBlockNumber()) {
          setBlockNumber(other.getBlockNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 34: {
              setInstanceId(input.readString());
              break;
            }
            case 1610: {
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addRows(subBuilder.buildPartial());
              break;
            }
            case 2400: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State value = ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(300, rawValue);
              } else {
                setBlockState(value);
              }
              break;
            }
            case 2408: {
              setBlockNumber(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 messageType = 2;
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 0;
        return this;
      }
      
      // optional string instanceId = 4;
      public boolean hasInstanceId() {
        return result.hasInstanceId();
      }
      public java.lang.String getInstanceId() {
        return result.getInstanceId();
      }
      public Builder setInstanceId(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasInstanceId = true;
        result.instanceId_ = value;
        return this;
      }
      public Builder clearInstanceId() {
        result.hasInstanceId = false;
        result.instanceId_ = getDefaultInstance().getInstanceId();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse.Row rows = 201;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row> getRowsList() {
        return java.util.Collections.unmodifiableList(result.rows_);
      }
      public int getRowsCount() {
        return result.getRowsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row getRows(int index) {
        return result.getRows(index);
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.rows_.set(index, value);
        return this;
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.Builder builderForValue) {
        result.rows_.set(index, builderForValue.build());
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row>();
        }
        result.rows_.add(value);
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.Builder builderForValue) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row>();
        }
        result.rows_.add(builderForValue.build());
        return this;
      }
      public Builder addAllRows(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row> values) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row>();
        }
        super.addAll(values, result.rows_);
        return this;
      }
      public Builder clearRows() {
        result.rows_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
      public boolean hasBlockState() {
        return result.hasBlockState();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State getBlockState() {
        return result.getBlockState();
      }
      public Builder setBlockState(ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasBlockState = true;
        result.blockState_ = value;
        return this;
      }
      public Builder clearBlockState() {
        result.hasBlockState = false;
        result.blockState_ = ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.State.NORMAL;
        return this;
      }
      
      // optional int32 blockNumber = 301;
      public boolean hasBlockNumber() {
        return result.hasBlockNumber();
      }
      public int getBlockNumber() {
        return result.getBlockNumber();
      }
      public Builder setBlockNumber(int value) {
        result.hasBlockNumber = true;
        result.blockNumber_ = value;
        return this;
      }
      public Builder clearBlockNumber() {
        result.hasBlockNumber = false;
        result.blockNumber_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse)
    }
    
    static {
      defaultInstance = new SpeedAndStatesResponse(true);
      ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponse)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\034SpeedAndStatesResponse.proto\022,ru.omnic" +
      "omm.pegasus.messaging.data.responses\"\307\002\n" +
      "\026SpeedAndStatesResponse\022\023\n\013messageType\030\002" +
      " \002(\005\022\022\n\ninstanceId\030\004 \001(\t\022W\n\004rows\030\311\001 \003(\0132" +
      "H.ru.omnicomm.pegasus.messaging.data.res" +
      "ponses.SpeedAndStatesResponse.Row\022H\n\nblo" +
      "ckState\030\254\002 \001(\01623.ru.omnicomm.pegasus.mes" +
      "saging.data.responses.State\022\024\n\013blockNumb" +
      "er\030\255\002 \001(\005\032K\n\003Row\022\021\n\tvehicleId\030e \002(\t\022\021\n\tp" +
      "ointDate\030f \002(\001\022\r\n\005speed\030g \002(\001\022\017\n\007stateId",
      "\030h \003(\t*,\n\005State\022\n\n\006NORMAL\020\000\022\010\n\004LAST\020\001\022\r\n" +
      "\tDEFECTIVE\020\002BL\n,ru.omnicomm.pegasus.mess" +
      "aging.data.responsesB\034SpeedAndStatesResp" +
      "onseParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_descriptor,
              new java.lang.String[] { "MessageType", "InstanceId", "Rows", "BlockState", "BlockNumber", },
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.class,
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_SpeedAndStatesResponse_Row_descriptor,
              new java.lang.String[] { "VehicleId", "PointDate", "Speed", "StateId", },
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.class,
              ru.omnicomm.pegasus.messaging.data.responses.SpeedAndStatesResponseParser.SpeedAndStatesResponse.Row.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
